//////////////////
// Windows Main //
//////////////////

#include "epp.epp"
#include "main.epp"

HINSTANCE EPP_INSTANCE;
HINSTANCE EPP_PREVIOUS;
LPSTR EPP_COMMANDLINE;
int EPP_SHOWCOMMAND;
char EPP_HELPFILE [MAX_PATH];

static void GetHelpFile ()
{
    const char *ext = ".hlp";
    char *ptr;
    int len, cnt;

    GetModuleFileName (NULL, EPP_HELPFILE, sizeof (EPP_HELPFILE));

    cnt = len = strlen (EPP_HELPFILE);
    ptr = EPP_HELPFILE + len - 1;

    while (cnt && (*ptr != '.') && (*ptr != '\\')) {
        cnt --;
        ptr --;
    }

    if (!cnt || (*ptr != '.'))
        ptr = EPP_HELPFILE + len;

    while (*ext)
        *ptr++ = *ext++;

    *ptr++ = NULL;
}


int WinMain (HINSTANCE inst, HINSTANCE pinst, LPSTR cmdl, int show)
  {
  EPP_INSTANCE = inst;
  EPP_PREVIOUS = pinst;
  EPP_COMMANDLINE = cmdl;
  EPP_SHOWCOMMAND = show;

  GetHelpFile ();
  InitCommonControls ();

  int epp_Main ();
  return epp_Main ();
  }